diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/FedTime.cc certi/libCERTI/FedTime.cc
--- certi.orig/libCERTI/FedTime.cc	2008-12-10 18:23:34.000000000 +0100
+++ certi/libCERTI/FedTime.cc	2008-12-13 18:28:14.000000000 +0100
@@ -17,241 +17,101 @@
 // You should have received a copy of the GNU Lesser General Public
 // License along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+//
+// $Id: FedRegion.hh,v 3.4 2008/12/07 20:16:13 gotthardp Exp $
 // ----------------------------------------------------------------------------
 
 #include <math.h>
 
-#include "certi.hh"
-#include "fedtime.hh"
-#include "HLAtypesIEEE1516.hh"
-
-#ifdef _WIN32
-	#ifdef max
-		#undef max
-	#endif
-#endif
+#include "FedTimeD.hh"
 
-#include <algorithm>
 #include <limits>
 #include <sstream>
-#include <typeinfo>
 
-using std::stringstream ;
-
-typedef RTI::FedTime FedTime ;
-typedef RTI::Double Double ;
+using namespace certi;
 
 namespace
 {
 
-// ----------------------------------------------------------------------------
-/** FedTime to RTIfedTime reference cast
- */
-inline const RTIfedTime &
-rft(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
-{
-    try {
-	return dynamic_cast<const RTIfedTime &>(time);
-    }
-    catch (std::bad_cast) {
-	throw RTI::InvalidFederationTime("Could not cast to RTIfedTime");
-    }
-}
-
-inline bool
-is_infinity(const FedTime &time)
-{
-    return const_cast<FedTime &>(time).isPositiveInfinity() == RTI::RTI_TRUE ;
-}
-
-/*
- fcmp
- Copyright (c) 1998-2000 Theodore C. Belding
- University of Michigan Center for the Study of Complex Systems
- <mailto:Ted.Belding@umich.edu>
- <http://fcmp.sourceforge.net>
-
- This file is part of the fcmp distribution. fcmp is free software;
- you can redistribute and modify it under the terms of the GNU Library
- General Public License (LGPL), version 2 or later.  This software
- comes with absolutely no warranty. See the file COPYING for details
- and terms of copying.
-
- Description:
-
- Knuth's floating point comparison operators, from:
- Knuth, D. E. (1998). The Art of Computer Programming.
- Volume 2: Seminumerical Algorithms. 3rd ed. Addison-Wesley.
- Section 4.2.2, p. 233. ISBN 0-201-89684-2.
-
- Input parameters:
- x1, x2: numbers to be compared
- epsilon: determines tolerance
-
- epsilon should be carefully chosen based on the machine's precision,
- the observed magnitude of error, the desired precision, and the
- magnitude of the numbers to be compared. See the fcmp README file for
- more information.
-
- This routine may be used for both single-precision (float) and
- double-precision (double) floating-point numbers.
-
- Returns:
- -1 if x1 < x2
-  0 if x1 == x2
-  1 if x1 > x2
-*/
-
-inline int
-fcmp(double x1,double x2, double epsilon)
-{
-    int exponent;
-    double delta;
-    double difference;
-
-    /* Get exponent(max(fabs(x1), fabs(x2))) and store it in exponent. */
-
-    /* If neither x1 nor x2 is 0, */
-    /* this is equivalent to max(exponent(x1), exponent(x2)). */
-
-    /* If either x1 or x2 is 0, its exponent returned by frexp would be 0, */
-    /* which is much larger than the exponents of numbers close to 0 in */
-    /* magnitude. But the exponent of 0 should be less than any number */
-    /* whose magnitude is greater than 0. */
-
-    /* So we only want to set exponent to 0 if both x1 and */
-    /* x2 are 0. Hence, the following works for all x1 and x2. */
-
-    frexp(fabs(x1) > fabs(x2) ? x1 : x2, &exponent);
-
-    /* Do the comparison. */
-
-    /* delta = epsilon * pow(2, exponent) */
-
-    /* Form a neighborhood around x2 of size delta in either direction. */
-    /* If x1 is within this delta neighborhood of x2, x1 == x2. */
-    /* Otherwise x1 > x2 or x1 < x2, depending on which side of */
-    /* the neighborhood x1 is on. */
-
-    delta = ldexp(epsilon, exponent);
-
-    difference = x1 - x2;
-
-    if (difference > delta)
-        return 1; /* x1 > x2 */
-    else if (difference < -delta)
-        return -1;  /* x1 < x2 */
-    else /* -delta <= difference <= delta */
-        return 0;  /* x1 == x2 */
-}
-
 const char *infinity_str = "+inf" ;
 
 } // anonymous namespace
 
 // ----------------------------------------------------------------------------
-// FedTimeFactory
-RTI::FedTime *
-RTI::FedTimeFactory::makeZero()
-    throw (RTI::MemoryExhausted)
-{
-    return new RTIfedTime();
-}
-
-RTI::FedTime *
-RTI::FedTimeFactory::decode(const char *)
-    throw (RTI::MemoryExhausted)
-{
-    throw RTI::RTIinternalError("Not implemented");
-}
-
-// ----------------------------------------------------------------------------
 // FedTime
-//FedTime::~FedTime()
-//{
-//}
 
-const double RTIfedTime::epsilon = std::numeric_limits<double>::epsilon();
+const double FedTime::epsilon = std::numeric_limits<double>::epsilon();
 
 int
-RTIfedTime::fcmp(const double x1, const double x2) {
-	return ::fcmp(x1,x2,RTIfedTime::epsilon);
+FedTime::fcmp(const double x1, const double x2) {
+	return certi::fcmp(x1,x2,FedTime::epsilon);
 }
 
 // ----------------------------------------------------------------------------
-// RTIfedTime
-RTIfedTime::RTIfedTime()
+// FedTime
+FedTime::FedTime()
     : _fedTime(0),
       _zero(0),
-      _epsilon(RTIfedTime::epsilon),
+      _epsilon(FedTime::epsilon),
       _positiveInfinity(std::numeric_limits<double>::infinity()) { }
 
-RTIfedTime::RTIfedTime(const RTI::Double &time)
+FedTime::FedTime(const double &time)
     : _fedTime(time),
       _zero(0),
-      _epsilon(RTIfedTime::epsilon),
+      _epsilon(FedTime::epsilon),
       _positiveInfinity(std::numeric_limits<double>::infinity()) { }
 
-RTIfedTime::RTIfedTime(const FedTime &time)
-    : _fedTime(rft(time).getTime()),
-      _zero(0),
-      _epsilon(RTIfedTime::epsilon),
-      _positiveInfinity(std::numeric_limits<double>::infinity()) { }
-
-// ----------------------------------------------------------------------------
-RTIfedTime::RTIfedTime(const RTIfedTime &time)
-    : FedTime(),
-      _fedTime(time._fedTime),
+FedTime::FedTime(const FedTime &time)
+    : _fedTime(time._fedTime),
       _zero(time._zero),
       _epsilon(time._epsilon),
       _positiveInfinity(time._positiveInfinity) { }
 
 // ----------------------------------------------------------------------------
-RTIfedTime::~RTIfedTime()
+FedTime::~FedTime()
 {
 }
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::setZero()
+FedTime::setZero()
 {
     _fedTime = _zero;
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::isZero()
+bool
+FedTime::isZero()
 {
-    return RTI::Boolean(_fedTime == _zero);
+    return bool(_fedTime == _zero);
 }
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::setEpsilon()
+FedTime::setEpsilon()
 {
     _fedTime = _epsilon;
 }
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::setPositiveInfinity()
+FedTime::setPositiveInfinity()
 {
     _fedTime = _positiveInfinity;
 }
 
 // ----------------------------------------------------------------------------
-inline RTI::Boolean
-RTIfedTime::isPositiveInfinity()
+inline bool
+FedTime::isPositiveInfinity() const
 {
-    return RTI::Boolean(_fedTime == _positiveInfinity);
+    return bool(_fedTime == _positiveInfinity);
 }
 
 // ----------------------------------------------------------------------------
 int
-RTIfedTime::encodedLength() const
+FedTime::encodedLength() const
 {
-	// current implementation of RTIfedtime takes
+	// current implementation of FedTime takes
 	// four IEEE-754 double values.
 	return (sizeof(_fedTime)+
 			sizeof(_zero)+
@@ -261,20 +121,20 @@
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::encode(char *buffer) const
+FedTime::encode(char *buffer) const
 {
-	libhla::HLAfloat64LE encoded_fedTime;
-	encoded_fedTime = _fedTime;
-	strncpy(buffer,(char*)&(encoded_fedTime),encoded_fedTime.__sizeof());
+//	libhla::HLAfloat64LE encoded_fedTime;
+//	encoded_fedTime = _fedTime;
+//	strncpy(buffer,(char*)&(encoded_fedTime),encoded_fedTime.__sizeof());
 }
 
 // ----------------------------------------------------------------------------
 int
-RTIfedTime::getPrintableLength() const
+FedTime::getPrintableLength() const
 {
-    stringstream s ;
+    std::stringstream s ;
 
-    if (is_infinity(*this))
+    if (isPositiveInfinity())
 	s << infinity_str ;
     else
 	s << _fedTime ;
@@ -284,11 +144,11 @@
 
 // ----------------------------------------------------------------------------
 void
-RTIfedTime::getPrintableString(char *str)
+FedTime::getPrintableString(char *str)
 {
-    stringstream s ;
+    std::stringstream s ;
 
-    if (is_infinity(*this))
+    if (isPositiveInfinity())
 	s << infinity_str ;
     else
 	s << _fedTime ;
@@ -299,127 +159,107 @@
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator+=(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator+=(const FedTime &time)
 {
-    _fedTime += rft(time)._fedTime ;
+    _fedTime += time._fedTime ;
     return *this;
 }
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator-=(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator-=(const FedTime &time)
 {
-    _fedTime -= rft(time)._fedTime ;
+    _fedTime -= time._fedTime ;
     return *this;
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator<=(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator<=(const FedTime &time) const
 {
     if (const_cast<FedTime &>(time).isPositiveInfinity())
-	return RTI::RTI_TRUE ;
-    else if (is_infinity(*this))
-	return RTI::RTI_FALSE ;
+	return true;
+    else if (isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) <= 0);
+	return bool(::fcmp(_fedTime, time._fedTime, _epsilon) <= 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator<(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator<(const FedTime &time) const
 {
-    if (is_infinity(*this))
-	return RTI::RTI_FALSE ;
+    if (isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(is_infinity(time) || ::fcmp(_fedTime, rft(time)._fedTime, _epsilon) < 0);
+	return bool(time.isPositiveInfinity() || ::fcmp(_fedTime, time._fedTime, _epsilon) < 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator>=(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator>=(const FedTime &time) const
 {
-    if (is_infinity(*this))
-	return RTI::RTI_TRUE ;
-    else if (is_infinity(time))
-	return RTI::RTI_FALSE ;
+    if (isPositiveInfinity())
+	return true;
+    else if (time.isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) >= 0);
+	return bool(::fcmp(_fedTime, time._fedTime, _epsilon) >= 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator>(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator>(const FedTime &time) const
 {
-    if (is_infinity(time))
-	return RTI::RTI_FALSE ;
+    if (time.isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(is_infinity(*this) || ::fcmp(_fedTime, rft(time)._fedTime, _epsilon) > 0);
+	return bool(isPositiveInfinity() || ::fcmp(_fedTime, time._fedTime, _epsilon) > 0);
 }
 
 // ----------------------------------------------------------------------------
-inline RTI::Boolean
-RTIfedTime::operator==(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator==(const FedTime &time) const
 {
-    if (is_infinity(*this) && is_infinity(time))
-	return RTI::RTI_TRUE ;
-    else if (is_infinity(*this) || is_infinity(time))
-	return RTI::RTI_FALSE ;
+    if (isPositiveInfinity() && time.isPositiveInfinity())
+	return true;
+    else if (isPositiveInfinity() || time.isPositiveInfinity())
+	return false;
     else
-	return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) == 0);
-}
-
-// ----------------------------------------------------------------------------
-FedTime &
-RTIfedTime::operator=(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
-{
-    _fedTime = rft(time)._fedTime ;
-    return *this ;
+	return bool(::fcmp(_fedTime, time._fedTime, _epsilon) == 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Double
-RTIfedTime::getTime() const
+double
+FedTime::getTime() const
 {
     return _fedTime ;
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator==(const Double &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator==(const double &time) const
 {
-    return RTI::Boolean(!is_infinity(*this) && ::fcmp(_fedTime, time, _epsilon) == 0);
+    return bool(!isPositiveInfinity() && ::fcmp(_fedTime, time, _epsilon) == 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator!=(const FedTime &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator!=(const FedTime &time) const
 {
-    return RTI::Boolean(::fcmp(_fedTime, rft(time)._fedTime, _epsilon) != 0);
+    return bool(::fcmp(_fedTime, time._fedTime, _epsilon) != 0);
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
-RTIfedTime::operator!=(const Double &time) const
-    throw (RTI::InvalidFederationTime)
+bool
+FedTime::operator!=(const double &time) const
 {
-    return RTI::Boolean(is_infinity(*this) || ::fcmp(_fedTime, time, _epsilon) != 0);
+    return bool(isPositiveInfinity() || ::fcmp(_fedTime, time, _epsilon) != 0);
 }
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator=(const RTIfedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator=(const FedTime &time)
 {
     _fedTime = time._fedTime ;
     return *this ;
@@ -427,170 +267,158 @@
 
 // ----------------------------------------------------------------------------
 FedTime &
-RTIfedTime::operator=(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator=(const double &time)
 {
     _fedTime = time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator*=(const RTI::FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator*=(const FedTime &time)
 {
-    _fedTime *= rft(time)._fedTime ;
+    _fedTime *= time._fedTime ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator/=(const RTI::FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator/=(const FedTime &time)
 {
-    _fedTime /= rft(time)._fedTime ;
+    _fedTime /= time._fedTime ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator+=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator+=(const double &time)
 {
     _fedTime += time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator-=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator-=(const double &time)
 {
     _fedTime -= time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator*=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator*=(const double &time)
 {
     _fedTime *= time ;
     return *this ;
 }
 
 FedTime &
-RTIfedTime::operator/=(const RTI::Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime::operator/=(const double &time)
 {
     _fedTime /= time ;
     return *this ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator+(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator+(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime + rft(time)._fedTime ;
+    FedTime fedtime = _fedTime + time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator+(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator+(const double &time)
 {
-    RTIfedTime fedtime = _fedTime + time ;
+    FedTime fedtime = _fedTime + time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator-(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator-(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime - rft(time)._fedTime ;
+    FedTime fedtime = _fedTime - time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator-(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator-(const double &time)
 {
-    RTIfedTime fedtime = _fedTime - time ;
+    FedTime fedtime = _fedTime - time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator*(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator*(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime * rft(time)._fedTime ;
+    FedTime fedtime = _fedTime * time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator*(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator*(const double &time)
 {
-    RTIfedTime fedtime = _fedTime * time ;
+    FedTime fedtime = _fedTime * time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-RTIfedTime::operator/(const FedTime &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator/(const FedTime &time)
 {
-    RTIfedTime fedtime = _fedTime / rft(time)._fedTime ;
+    FedTime fedtime = _fedTime / time._fedTime ;
     return fedtime ;
 }
 
-RTIfedTime
-RTIfedTime::operator/(const Double &time)
-    throw (RTI::InvalidFederationTime)
+FedTime
+FedTime::operator/(const double &time)
 {
-    RTIfedTime fedtime = _fedTime / time ;
+    FedTime fedtime = _fedTime / time ;
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
 std::ostream &
-operator<<(std::ostream &s, const FedTime &time)
+certi::operator<<(std::ostream &s, const FedTime &time)
 {
-    if (is_infinity(time))
+    if (time.isPositiveInfinity())
 	s << infinity_str ;
     else
-	s << rft(time).getTime();
+	s << time.getTime();
     return s ;
 }
 
 // ============================================================================
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator+(const Double &d, const FedTime &time)
+FedTime
+operator+(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d + rft(time).getTime();
+    FedTime fedtime = d + time.getTime();
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator-(const Double &d, const FedTime &time)
+FedTime
+operator-(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d - rft(time).getTime();
+    FedTime fedtime = d - time.getTime();
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator*(const Double &d, const FedTime &time)
+FedTime
+operator*(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d * rft(time).getTime();
+    FedTime fedtime = d * time.getTime();
     return fedtime ;
 }
 
 // ----------------------------------------------------------------------------
-RTIfedTime
-operator/(const Double &d, const FedTime &time)
+FedTime
+operator/(const double &d, const FedTime &time)
 {
-    RTIfedTime fedtime = d / rft(time).getTime();
+    FedTime fedtime = d / time.getTime();
     return fedtime ;
 }
+
+// $Id: FedRegion.hh,v 3.4 2008/12/07 20:16:13 gotthardp Exp $
+
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/FedTimeD.hh certi/libCERTI/FedTimeD.hh
--- certi.orig/libCERTI/FedTimeD.hh	1970-01-01 01:00:00.000000000 +0100
+++ certi/libCERTI/FedTimeD.hh	2008-12-13 18:28:03.000000000 +0100
@@ -0,0 +1,185 @@
+// ----------------------------------------------------------------------------
+// CERTI - HLA RunTime Infrastructure
+// Copyright (C) 2002-2005  ONERA
+//
+// This file is part of CERTI-libCERTI
+//
+// CERTI-libCERTI is free software ; you can redistribute it and/or
+// modify it under the terms of the GNU Lesser General Public License
+// as published by the Free Software Foundation ; either version 2 of
+// the License, or (at your option) any later version.
+//
+// CERTI-libCERTI is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY ; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+// Lesser General Public License for more details.
+//
+// You should have received a copy of the GNU Lesser General Public
+// License along with this program ; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+// USA
+//
+// $Id: FedRegion.hh,v 3.4 2008/12/07 20:16:13 gotthardp Exp $
+// ----------------------------------------------------------------------------
+
+#ifndef CERTI_FEDTIMED_HH
+#define CERTI_FEDTIMED_HH
+
+#include <math.h>
+#include <ostream>
+
+namespace certi {
+
+/*
+ fcmp
+ Copyright (c) 1998-2000 Theodore C. Belding
+ University of Michigan Center for the Study of Complex Systems
+ <mailto:Ted.Belding@umich.edu>
+ <http://fcmp.sourceforge.net>
+
+ This file is part of the fcmp distribution. fcmp is free software;
+ you can redistribute and modify it under the terms of the GNU Library
+ General Public License (LGPL), version 2 or later.  This software
+ comes with absolutely no warranty. See the file COPYING for details
+ and terms of copying.
+
+ Description:
+
+ Knuth's floating point comparison operators, from:
+ Knuth, D. E. (1998). The Art of Computer Programming.
+ Volume 2: Seminumerical Algorithms. 3rd ed. Addison-Wesley.
+ Section 4.2.2, p. 233. ISBN 0-201-89684-2.
+
+ Input parameters:
+ x1, x2: numbers to be compared
+ epsilon: determines tolerance
+
+ epsilon should be carefully chosen based on the machine's precision,
+ the observed magnitude of error, the desired precision, and the
+ magnitude of the numbers to be compared. See the fcmp README file for
+ more information.
+
+ This routine may be used for both single-precision (float) and
+ double-precision (double) floating-point numbers.
+
+ Returns:
+ -1 if x1 < x2
+  0 if x1 == x2
+  1 if x1 > x2
+*/
+
+inline int
+fcmp(double x1,double x2, double epsilon)
+{
+    int exponent;
+    double delta;
+    double difference;
+
+    /* Get exponent(max(fabs(x1), fabs(x2))) and store it in exponent. */
+
+    /* If neither x1 nor x2 is 0, */
+    /* this is equivalent to max(exponent(x1), exponent(x2)). */
+
+    /* If either x1 or x2 is 0, its exponent returned by frexp would be 0, */
+    /* which is much larger than the exponents of numbers close to 0 in */
+    /* magnitude. But the exponent of 0 should be less than any number */
+    /* whose magnitude is greater than 0. */
+
+    /* So we only want to set exponent to 0 if both x1 and */
+    /* x2 are 0. Hence, the following works for all x1 and x2. */
+
+    frexp(fabs(x1) > fabs(x2) ? x1 : x2, &exponent);
+
+    /* Do the comparison. */
+
+    /* delta = epsilon * pow(2, exponent) */
+
+    /* Form a neighborhood around x2 of size delta in either direction. */
+    /* If x1 is within this delta neighborhood of x2, x1 == x2. */
+    /* Otherwise x1 > x2 or x1 < x2, depending on which side of */
+    /* the neighborhood x1 is on. */
+
+    delta = ldexp(epsilon, exponent);
+
+    difference = x1 - x2;
+
+    if (difference > delta)
+        return 1; /* x1 > x2 */
+    else if (difference < -delta)
+        return -1;  /* x1 < x2 */
+    else /* -delta <= difference <= delta */
+        return 0;  /* x1 == x2 */
+}
+
+class FedTime
+{
+public:
+    static const double epsilon;
+    static int fcmp(const double x1, const double x2);
+
+    FedTime();
+    FedTime(const double &);
+    FedTime(const FedTime &);
+    ~FedTime();
+
+public:
+    void setZero();
+    bool isZero();
+    void setEpsilon();
+    void setPositiveInfinity();
+    bool isPositiveInfinity() const;
+    int encodedLength() const;
+    void encode(char *) const;
+    int getPrintableLength() const;
+    void getPrintableString(char *);
+    double getTime() const;
+
+    FedTime& operator+=(const FedTime &);
+    FedTime& operator-=(const FedTime &);
+    bool operator<=(const FedTime &) const;
+    bool operator<(const FedTime &) const;
+    bool operator>=(const FedTime &) const;
+    bool operator>(const FedTime &) const;
+    bool operator==(const FedTime &) const;
+    bool operator==(const double &) const;
+    bool operator!=(const FedTime &) const;
+    bool operator!=(const double &) const;
+    FedTime &operator=(const FedTime &);
+    FedTime &operator=(const double &);
+    FedTime &operator*=(const FedTime &);
+    FedTime &operator/=(const FedTime &);
+    FedTime &operator+=(const double &);
+    FedTime &operator-=(const double &);
+    FedTime &operator*=(const double &);
+    FedTime &operator/=(const double &);
+    FedTime operator+(const FedTime &);
+    FedTime operator+(const double &);
+    FedTime operator-(const FedTime &);
+    FedTime operator-(const double &);
+    FedTime operator*(const FedTime &);
+    FedTime operator*(const double &);
+    FedTime operator/(const FedTime &);
+    FedTime operator/(const double &);
+
+    friend std::ostream &operator<<(std::ostream&, const FedTime &time);
+
+private:
+    double _fedTime ;
+    double _zero ;
+    double _epsilon ;
+    double _positiveInfinity ;
+};
+
+FedTime operator+(const double &, const FedTime &);
+FedTime operator-(const double &, const FedTime &);
+FedTime operator*(const double &, const FedTime &);
+FedTime operator/(const double &, const FedTime &);
+
+typedef FedTime FederationTime;
+typedef FedTime FederationTimeDelta;
+
+} // namespace certi
+
+#endif // CERTI_FEDTIMED_HH
+
+// $Id: fedtime.hh,v 3.12 2008/12/10 17:42:43 gotthardp Exp $
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/GAV.cc certi/libCERTI/GAV.cc
--- certi.orig/libCERTI/GAV.cc	2008-12-07 11:39:03.000000000 +0100
+++ certi/libCERTI/GAV.cc	2008-12-13 06:58:39.000000000 +0100
@@ -159,14 +159,6 @@
 }
 
 // ----------------------------------------------------------------------------
-RTI::Region *
-AttributeHandleValuePairSet::getRegion(ULong) const
-    throw (ArrayIndexOutOfBounds, InvalidHandleValuePairSetContext)
-{
-    throw RTIinternalError("Unimplemented service");
-}
-
-// ----------------------------------------------------------------------------
 void
 AttributeHandleValuePairSet::add(Handle h,
                                     const char *buff,
@@ -286,7 +278,7 @@
 AttributeHandleSet::remove(AttributeHandle h)
     throw (AttributeNotDefined)// not guaranteed safe while iterating
 {
-    if (isMember(h) == RTI::RTI_TRUE)
+    if (isMember(h) == true)
         list<AttributeHandle>::remove(h);
     else
         throw AttributeNotDefined("");
@@ -300,17 +292,17 @@
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
+bool
 AttributeHandleSet::isEmpty() const
 {
-    return RTI::Boolean(list<AttributeHandle>::empty());
+    return list<AttributeHandle>::empty();
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
+bool
 AttributeHandleSet::isMember(AttributeHandle h) const
 {
-    return RTI::Boolean(find(begin(), end(), h) != end());
+    return find(begin(), end(), h) != end();
 }
 
 // ----------------------------------------------------------------------------
@@ -356,7 +348,7 @@
 FederateHandleSet::remove(FederateHandle h)
     throw (ArrayIndexOutOfBounds)
 {
-    if (isMember(h) == RTI::RTI_TRUE)
+    if (isMember(h) == true)
         list<FederateHandle>::remove(h);
     else
         throw AttributeNotDefined("");
@@ -370,10 +362,10 @@
 }
 
 // ----------------------------------------------------------------------------
-RTI::Boolean
+bool
 FederateHandleSet::isMember(FederateHandle h) const
 {
-    return RTI::Boolean(find(begin(), end(), h) != end());
+    return find(begin(), end(), h) != end();
 }
 
 // ----------------------------------------------------------------------------
@@ -499,14 +491,6 @@
 }
 
 // ----------------------------------------------------------------------------
-RTI::Region *
-ParameterHandleValuePairSet::getRegion() const
-    throw (InvalidHandleValuePairSetContext)
-{
-    throw RTIinternalError("Unimplemented service");
-}
-
-// ----------------------------------------------------------------------------
 void
 ParameterHandleValuePairSet::add(Handle h,
                                     const char *buff,
diff -Nru --exclude=CVS --exclude=CMakeFiles certi.orig/libCERTI/GAV.hh certi/libCERTI/GAV.hh
--- certi.orig/libCERTI/GAV.hh	2008-12-07 11:39:03.000000000 +0100
+++ certi/libCERTI/GAV.hh	2008-12-13 06:58:48.000000000 +0100
@@ -47,8 +47,8 @@
 
     virtual void empty();
 
-    virtual RTI::Boolean isEmpty() const ;
-    virtual RTI::Boolean isMember(AttributeHandle h) const ;
+    virtual bool isEmpty() const ;
+    virtual bool isMember(AttributeHandle h) const ;
 };
 
 class FederateHandleSet : public std::list<FederateHandle>
@@ -70,7 +70,7 @@
 
     virtual void empty();
 
-    virtual RTI::Boolean isMember(FederateHandle h) const ;
+    virtual bool isMember(FederateHandle h) const ;
 };
 
 class AttributeHandleValuePair
@@ -118,9 +118,6 @@
     virtual OrderType getOrderType(ULong i) const
         throw (ArrayIndexOutOfBounds, InvalidHandleValuePairSetContext);
 
-    virtual RTI::Region *getRegion(ULong i) const
-        throw (ArrayIndexOutOfBounds, InvalidHandleValuePairSetContext);
-
     virtual void add(Handle h, const char *buff, ULong valueLength)
         throw (ValueLengthExceeded, ValueCountExceeded);
     virtual void remove(Handle h) throw (ArrayIndexOutOfBounds);
@@ -174,9 +171,6 @@
     virtual OrderType getOrderType() const
         throw (InvalidHandleValuePairSetContext);
 
-    virtual RTI::Region *getRegion() const
-        throw (InvalidHandleValuePairSetContext);
-
     virtual void add(Handle h, const char *buff, ULong valueLength)
         throw (ValueLengthExceeded, ValueCountExceeded);
 
